//	LN^LCD/HD44780݊Rg[pCu
//	wt]xH쎺	http://jsdiy.web.fc2.com

#include	<avr/io.h>
#include	<util/delay.h>
#include	"HD44780_lcdlib.h"


//SUNLIKE [SC1602]												|[SD1602]
//pin:	14	13	12	11	10	9	8	7	6	5	4	3	2	1	|16	15
//bit:	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0	E	R/W	RS	Vo	VDD	VSS	|K	A
//		<- 4bit mode ->									+V	GND	|-	+

//gp|[giP̃|[gj
#define	LCD_PORT	PORTA
#define	LCD_DDR		DDRA

//|[g̃rbg̊蓖āi4bit[hOj
#define	LCD_FIXBITS	((1 << PORTA7) | (1 << PORTA6))	//LCD̐Ƃ͖֌Wȃrbgɒ`i0j
#define	LCD_RS		(1 << PORTA0)	//Register Select	H:data	L:command
#define	LCD_RW		0				//Read/Write		H:read	L:write		gpin[hIwriteŒj
#define	LCD_E		(1 << PORTA1)	//Enable Signal		H->L:strobe
#define	LCD_DATABITS_SHIFT	2	//PA5-PA2	iPORTLSB牽rbg߂f[^rbgBFbit3-0Ȃ0Abit7-4Ȃ4j
#define	LCD_DATABITS	(0x0F << LCD_DATABITS_SHIFT)
#define	LCD_DATABITS_REVERSE	0	//f[^4bit̐ڑΉ	0:[MSB/DB7`DB4/LSB]	1:[MSB/DB4`DB7/LSB]


//LCD\
typedef	struct
{
	uint8_t XColumnMax, YRowMax;
	uint8_t isCombine, isOverwrite;
	uint8_t cursorPosX, cursorPosY;
} TLcdInfo;

static	TLcdInfo	lcdInfo;

//4bit]
#if LCD_DATABITS_REVERSE
static	uint8_t	bitrev(uint8_t data)
{
	//data4bitł邱ƂO	//1234
	return	((data & 0x08) >> 3) |	//0001
	((data & 0x04) >> 1) |	//0021
	((data & 0x02) << 1) |	//0321
	((data & 0x01) << 3);	//4321
}
#endif

//LCDɃR}ho͂i4bitj
static	void	lcdCmd4bit(uint8_t data)
{
#if LCD_DATABITS_REVERSE
	data = bitrev(data);
#endif
	//data4bitł邱ƂO
	LCD_PORT = (LCD_PORT & LCD_FIXBITS) | LCD_E | (data << LCD_DATABITS_SHIFT);
	_delay_ms(1);
	LCD_PORT &= ~LCD_E;
	_delay_ms(1);
}

//LCDɃR}ho͂
void	lcdCmd(uint8_t data)
{
	lcdCmd4bit((data >> 4) & 0x0F);	//4bit
	lcdCmd4bit(data & 0x0F);		//4bit
	
	if (data == LCD_CMD_CLEAR_DISPLAY || data == LCD_CMD_RETURN_HOME )
		lcdInfo.cursorPosX = lcdInfo.cursorPosY = 0;
}

//LCDɃf[^o͂
void	lcdData(uint8_t data)
{
	uint8_t bits;
	
	bits = (data >> 4) & 0x0F;	//4bit
#if LCD_DATABITS_REVERSE
	bits = bitrev(bits);
#endif
	LCD_PORT = (LCD_PORT & LCD_FIXBITS) | LCD_RS | LCD_E | (bits << LCD_DATABITS_SHIFT);
	_delay_us(100);
	LCD_PORT &= ~LCD_E;
	_delay_us(100);
	
	bits = data & 0x0F;	//4bit
#if LCD_DATABITS_REVERSE
	bits = bitrev(bits);
#endif
	LCD_PORT = (LCD_PORT & LCD_FIXBITS) | LCD_RS | LCD_E | (bits << LCD_DATABITS_SHIFT);
	_delay_us(100);
	LCD_PORT &= ~LCD_E;
	_delay_us(100);
	
	LCD_PORT &= ~LCD_RS;
	_delay_us(100);
}

//LCD
void	lcdInit(uint8_t columnSize, uint8_t rowSize)
{
	LCD_DDR |= (LCD_E | LCD_RW | LCD_RS | LCD_DATABITS);
	LCD_PORT &= LCD_FIXBITS;

	_delay_ms(15);
	lcdCmd4bit(0b0011);
	_delay_ms(5);
	lcdCmd4bit(0b0011);
	_delay_us(100);
	lcdCmd4bit(0b0011);
	
	lcdCmd4bit(0b0010);		//4-bit[hֈڍs
	
	//   bit:76543210
	lcdCmd(0b00101000);		//Function Set	bit:5(1), DL=4-bit(0), N=2lines(1), F=5x8dots(0), *(0), *(0)
	lcdCmd(0b00001000);		//Display Set	bit:3(1), D=Set Display:NO(0), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
	lcdCmd(0b00000001);		//Clear Display	bit:0(1)
	lcdCmd(0b00000110);		//Entry Mode	bit:2(1), I/D=Increment(1), S=With Display Shift:NO(0)
	lcdCmd(0b00001100);		//Display Set	bit:3(1), D=Set Display:YES(1), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
	
	lcdInfo.cursorPosX = lcdInfo.cursorPosY = 0;
	lcdInfo.isCombine = lcdInfo.isOverwrite = 0;
	lcdInfo.XColumnMax = (columnSize < 1 ? 1 : columnSize);
	lcdInfo.YRowMax = (rowSize < 1 ? 1 : rowSize);
}

#define CMD_CursorOn	(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY | LCD_SUBCMD_CURSOR_BLINK)
#define CMD_CursorOff	(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY)

//usv̓샂[hZbg
//E㏑[h̏ꍇAǂ̈ʒu܂ŕ\i񂾂ȂȂ̂ŁAJ[\\ł悤ɂB
void	lcdSetLineMode(uint8_t lineMode, uint8_t cursorFlag)
{
	lcdInfo.isCombine = lineMode & LCD_LINEMODE_COMBINE;
	lcdInfo.isOverwrite = lineMode & LCD_LINEMODE_OVERWRITE;
	lcdCmd(cursorFlag ? CMD_CursorOn : CMD_CursorOff);
}

//\ʒuZbg
//Es,Ƃ0N_B
void	lcdSetPosXY(uint8_t x_column, uint8_t y_row)
{
	if (lcdInfo.XColumnMax <= x_column || lcdInfo.YRowMax <= y_row) return;
	lcdCmd(LCD_CMD_SET_DDRAM_ADRS | (y_row * 0x40 + x_column));
	lcdInfo.cursorPosX = x_column;
	lcdInfo.cursorPosY = y_row;
}

//1o͂
void	lcdPutChar(char c)
{
	if (lcdInfo.XColumnMax <= lcdInfo.cursorPosX || lcdInfo.YRowMax <= lcdInfo.cursorPosY) return;
	lcdData(c);
	lcdInfo.cursorPosX++;
	
	if (lcdInfo.cursorPosX == lcdInfo.XColumnMax)
	{
		if (lcdInfo.isCombine || lcdInfo.isOverwrite)
		{
			lcdInfo.cursorPosX = 0;
		}
		
		if (lcdInfo.isCombine)
		{
			lcdInfo.cursorPosY++;
			if (lcdInfo.cursorPosY == lcdInfo.YRowMax)
			{
				if (lcdInfo.isOverwrite)
				{
					lcdInfo.cursorPosY = 0;
				}
			}
		}
		
		lcdSetPosXY(lcdInfo.cursorPosX, lcdInfo.cursorPosY);
	}
}

//Ȃo͂i10i\Lj
void	lcdPutUInt(uint16_t n)
{
	int8_t	i = 0;
	uint8_t	kbuf[5];	//16bit͍̐ő5(65535)
	
	do
	{
		kbuf[i++] = n % 10;
		n /= 10;
	}
	while (0 < n);
	
	while (i != 0) lcdPutChar('0' + kbuf[--i]);
}

//萮o͂i10i\Lj
void	lcdPutInt(int16_t n)
{
	if (n < 0)
	{
		lcdPutChar('-');
		lcdPutUInt(-n);
	}
	else
	{
		lcdPutUInt(n);
	}
}

//1byte̒lo͂i16i\Lj
void	lcdPutByte(uint8_t n)
{
	int8_t bitShift;
	uint8_t hex, cc;
	
	for (bitShift = 4; 0 <= bitShift; bitShift -= 4)
	{
		hex = (n >> bitShift) & 0x0F;
		cc = (hex < 10) ? ('0' + hex) : ('A' + hex - 10);
		lcdPutChar(cc);
	}
}
