//	LN^LCD I2CA_v^
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATtiny20	x:݂Ȃ(PB3RESET) -:
bit		7	6	5	4	3	2	1	0
portA	SCL	-	LCD	LCD	LCD	LCD	LCD	LCD		TWI, LCD
portB	x	x	x	x	x	SA0	SDA	-		SLA-bit, TWI

yATtiny20z
|-AAAAAA|
|G012345|
>       |
|V01R276|
|-BB-BAA|

yq[Yrbgz(hidtpiw.exe -rf)
Low: -111-111 (FF)
      ||| ||+-- RSTDISBL (1:RESETgp, 0:RESET(PB3))
      ||| |+-- WDTON (WDT 0:펞ON, 1:ʏ)
      ||| +-- CKOUT (0:CLKOɃVXeNbNo)
      +++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)

yrhz
Atmel Studio 6 (Version: 6.0.1996 - Service Pack 2)
AVR Toolchain 8 Bit / Version: 3.4.1.830 - GCC  4.6.2
ATtiny20 8MHzi8MHz/Ȃj	œKIvV: -Os

yXVz
2014/01/14	v1.00	
	Program Memory Usage 	:	1424 bytes   69.5 % Full
	Data Memory Usage 		:	40 bytes   31.3 % Full
*/

/*	yATtiny10V[Ygp̒ӎz
E݂ėpWX^R16-R31^R17̓[WX^BX:R26-R27(Lo-Hi), Y:R28-R29(Lo-Hi), Z:R30-R31(Lo-Hi)
EI/Os̃vAbvPORTxWX^ł͂ȂPUExWX^Őݒ肷B
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "HD44780_lcdlib.h"
#include "I2cCharLcdCmd.h"

#define	nop()	asm volatile("nop"::)

static	void	SendACK();
static	void	SendNACK();
static	void	LcdFunction(uint8_t func);

//X[uAhX
#define SLAVE_ADDRESS_Base6bit	(0b011110 << 2)	//7bit6bitil8bitj

//Mobt@
#define	RCVBUF_LENGTH	(1 + (MAX_DATA_LENGTH))	//Rg[oCg{f[^oCg
static	uint8_t	RcvBuf[RCVBUF_LENGTH] = { 0 };	//Mobt@
static	uint8_t	rbidx;	//RcvBuf[]̃CfbNX

/*	yI2C}X^[^X[uԂ̒ʐMez
[S][SLA+W](A)[Rg[oCg](A)[f[^oCg](A)[P]
[S][SLA+W](A)[gRg[oCg](A)[f[^oCg1](A)c[f[^oCgn](A)[P]	1<=n<=MAX_DATA_LENGTH

EʐMf[^2byteꍇ͕sȒʐMƌȂB
ERg[oCg蓾ĺARS_CMD, RS_DATA, ELcdFunc ̂݁B
E1̒ʐMŃf[^oCg'MAX_DATA_LENGTH'oCg܂ŎMłAȍ~̃pPbgɂNACKB
*/
#define	CtrlByte	(RcvBuf[0])
static	uint8_t	GetRcvDataCount(){ return (rbidx < 2) ? 0 : (rbidx - 1); }	//Mf[^oCǧiRg[oCg͊܂܂Ȃj^f[^zɊi[ƂɃCNgĂ̂Ƃ
static	uint8_t*	GetRcvDataBytes(){ return &RcvBuf[1]; }	//Mobt@Rg[oCgc̃obt@

#define RegBit(r, b)	(((r) >> (b)) & 0x01)	//rWX^̑brbg(bit:7-0)擾(=1,0)
#define IsBitHi(r, b)	(RegBit(r, b) == 1)
#define IsBitLo(r, b)	(RegBit(r, b) == 0)
#define IsAdrsRcved(srA)	(IsBitHi(srA, TWASIF) && IsBitHi(srA, TWAS))
#define IsStopRcved(srA)	(IsBitHi(srA, TWASIF) && IsBitLo(srA, TWAS))
#define IsDataRcved(srA)	(IsBitHi(srA, TWDIF))
#define IsSLA_R(srA)	(IsBitHi(srA, TWDIR))
#define IsSLA_W(srA)	(IsBitLo(srA, TWDIR))

enum EState
{
	ST_LCDREADY,	//f[^MJnAXgbvRfBVɂLCDANZX҂܂
	ST_LCDFINISH	//LCDANZX
};

/*
ISR(TWI_SLAVE_vect)
{
	//
}
*/

int	main(void)
{
	uint8_t	slaveAddress;	//SLAVE_ADDRESS_Base6bit0/1ASȂX[uAhX7bitil8bitj
	uint8_t	i, statusRegA;
	uint8_t	status = ST_LCDFINISH;
	
	//VXeNbNݒ肷
	//CLKPS3-0 = 0000:Ȃ(8MHz), 0001:2(4MHz), 0010:4(2MHz), 0011:8(1MHz)[ftHg], c
	CCP = 0xD8;
	CLKPSR = (0b0000 < CLKPS0);
	_delay_ms(10);
	/*
	ATtiny20CPU=8MHzI2C100kHzɑΉBSCL݂̈NȂ悤IɏłꍇB
	400kHz肾SCL݂̈NAI400kHz̒ʐMx͏oȂB
	*/

	//d͍팸i1:@\~j
	PRR = (0 << PRTWI) | (1 << PRSPI) | (1 << PRTIM1) | (1 << PRTIM0) | (1 << PRADC);
	ACSRA = (1 << ACD);
	
	//gpsJMPs(PB2)vAbv
	PUEA = (1 << PUEA6);
	PUEB = (1 << PUEB2) | (1 << PUEB0);
	
	//JMPsOpen/Close𔻒肵AX[uAhX7bit(0b011110X)肷
	//Open:PB2=1 -> X=1, Close:PB2=0 -> X=0
	nop();	nop();
	slaveAddress = SLAVE_ADDRESS_Base6bit | (RegBit(PINB, PORTB2) << 1);
	TWSA = slaveAddress;
	
	//TWIWX^ݒ肷
	//TWSIE'1'ɂƁAXgbvRfBVoTWSSRA:TWASIF'1'ɂȂ
	TWSCRA = (1 << TWEN) | (1 << TWSIE);

	//d̏ƂăX[uAhX\
	lcdInit(8, 1);	//LCD̍ŏvi8x1sTCYj
	for (i = 7; 1 <= i; i--) lcdPutUInt((slaveAddress >> i) & 0x01);
	for (i = 0; i < 5; i++) _delay_ms(100);	//0.5b
	lcdCmd(LCD_CMD_CLEAR_DISPLAY);

	//sei();	//荞݊Jn
	
	while (1)
	{
		//X^[gRfBV{X[uAhXv҂, XgbvRfBV҂
		//f[^҂
		while (!((statusRegA = TWSSRA) & ((1 << TWASIF) | (1 << TWDIF))));

		if (IsAdrsRcved(statusRegA))
		{
			if (IsSLA_W(statusRegA))
			{
				//ÕXgbvRfBV肪RāÃX^[gRfBVĂ܂ꍇiیj
				//܂́il̏Ԃł邪jAXgbvRfBVł͂Ȃs[gX^[gRfBVꍇ
				//EO܂ł̎MeLCDɏo͂B					
				if (status != ST_LCDFINISH)
				{
					//lcdPutChar('n');
					LcdFunction(CtrlByte);
				}
				
				//SLA_WJn
				status = ST_LCDREADY;
				rbidx = 0;
				SendACK();
			}
			else //IsSLA_R()
			{
				SendNACK();
			}
			continue;
		}
		
		if (IsDataRcved(statusRegA))
		{
			if (rbidx < RCVBUF_LENGTH)
			{
				RcvBuf[rbidx++] = TWSD;	//̏I_rbidx͎Mf[^̌\Ă
				SendACK();
			}
			else
			{
				SendNACK();
			}
			continue;
		}
		
		if (IsStopRcved(statusRegA))
		{
			//lcdPutChar('P');
			if (status != ST_LCDFINISH)
			{
				LcdFunction(CtrlByte);
				status = ST_LCDFINISH;
			}
			
			TWSSRA |= (1 << TWASIF);	//TWASIFrbgi'1'ނƉj
		}
	}

	return 0;
}

//ACK
static	void	SendACK()
{
	TWSCRB = (0 << TWAA) | (0b11 << TWCMD0);
}

//NACK
//E}X^[ɍ̒ʐMIĂ炢AX[ũ͎X^[gRfBV҂B
static	void	SendNACK()
{
	TWSCRB = (1 << TWAA) | (0b10 << TWCMD0);
}

//gR}hs
static	void	LcdFunction(uint8_t func)
{
	uint8_t i, dataLength = GetRcvDataCount();
	uint8_t *datas = GetRcvDataBytes();
	uint16_t num;
	
	if (dataLength == 0) return;	//Mf[^Ȃꍇ͉Ȃ
	
	switch (func)
	{
	case RS_CMD:
		lcdCmd(datas[0]);
		break;
		
	case RS_DATA:
		for (i = 0; i < dataLength; i++) lcdData(datas[i]);
		break;
		
	case LCD_FUNC_INIT:		//LCĎ,s
		lcdInit(datas[0], datas[1]);
		break;
		
	case LCD_FUNC_SETLINEMODE:	//s̓B(LCD_LINEMODE_AAA | LCD_LINEMODE_BBB, LCD_CURSOR_ON)
		lcdSetLineMode(datas[0], datas[1]);
		break;
		
	case LCD_FUNC_SETPOS_XY:	//\ʒuB(x/column),s(y/row)̏2byte
		lcdSetPosXY(datas[0], datas[1]);
		break;
		
	case LCD_FUNC_PUTCHAR:	//R[h
		for (i = 0; i < dataLength; i++) lcdPutChar(datas[i]);
		break;
		
	case LCD_FUNC_PUTINT:	//萮B10i\B8bit/16bitƂHi-Lȍ2byte
		num = ((uint16_t)datas[0] << 8) | (uint16_t)datas[1];
		lcdPutInt(num);
		break;
		
	case LCD_FUNC_PUTUINT:	//ȂB10i\B8bit/16bitƂHi-Lȍ2byte
		num = ((uint16_t)datas[0] << 8) | (uint16_t)datas[1];
		lcdPutUInt(num);
		break;
		
	case LCD_FUNC_PUTBYTE:	//16i\
		for (i = 0; i < dataLength; i++) lcdPutByte(datas[i]);
		break;
		
	default:	break;
	}
}
